import uiModules from 'ui/modules';

import move from './move.js';
import narrow from './narrow.js';

/* eslint-disable max-len */
uiModules.get('app/dashboard', ['kibana/courier','ngRoute']).run(function ($rootScope, Private, $location, courier, $route, kbnUrl, getAppState, globalState, timefilter) {

  $rootScope.$on('$viewContentLoaded', function () {
    let href = window.location.href.substr(0, window.location.href.lastIndexOf('/'));
    parent.postMessage('kibana_iAP_portlet_plugin_viewContentLoaded###' + href, '*');
  });

  $rootScope.$watchMulti([
    '$$timefilter.time.from',
    '$$timefilter.time.to'
  ], function (rangeA) {
    var from = rangeA[0];
    var to = rangeA[1];
    if (!from || !to) {
      return;
    }
    let portletDispCd = $route.current.params.portletDispCd;
    parent.postMessage('kibana_iAP_portlet_plugin_timefilterchanged###' + from + '|' + to + '###' + portletDispCd, '*');
  });

  window.addEventListener('message', function (e) {
    let topic = e.data.split('###')[0];
    let portletDispCd = e.data.split('###')[1];
    let href = e.target.window.location.href;

    let params = {
      href: href,
      $location: $location,
      courier: courier,
      localAppState: getAppState(),
      localGlobalState: globalState,
      timeFilter: timefilter,
      portletDispCd: portletDispCd
    };

    switch (topic)
    {
      case 'change':
        move.change(params, e.data.split('###')[2]);
        return;
      case 'narrow':
        narrow.narrow(params, JSON.parse(decodeURIComponent(e.data.split('###')[2])), decodeURIComponent(e.data.split('###')[3]));
        return;
    }
    console.warn('Invalid message topic ' + topic + '!');
  },false);

});

